OBJDIR := obj
DEPDIR := obj

SOURCES := $(wildcard *.c)
OBJECTS := $(patsubst %.c,$(OBJDIR)/%.o,$(SOURCES))

CC := gcc
CFLAGS := -W -Wall -Wwrite-strings
#CFLAGS += -Wmissing-declarations -Wstrict-prototypes -Wno-system-headers

ifdef DEBUGMODE
CFLAGS += -g3
else
CFLAGS += -O2 -ffast-math -fomit-frame-pointer -funroll-loops
endif

LIBS := `allegro-config --libs`

ifdef EFENCE
LIBS += -lefence
endif

podfight: $(OBJECTS)
	$(CC) $^ -o $@ $(LIBS)

$(OBJDIR)/%.o: %.c
	$(CC) $(CFLAGS) -c $< -o $@

$(DEPDIR)/%.d: %.c
	$(CC) -MM $(CFLAGS) $< | sed -e "s/^$*\.o:/$(OBJDIR)\/$*\.o $(DEPDIR)\/$*\.d:/" > $@

-include $(patsubst %.c,$(DEPDIR)/%.d,$(SOURCES))
