#include "main.h"
#include "game.h"
#include "bsp.h"
#include "drawblt.h"



/* 4   5
 *   6   7
 *
 * 0   1   <-- back
 *   2   3   <-- front
 */



void init_bullet_polygons(BULLET *bullet)
{
	int i;
	for (i = 0; i < 6; i++) {
		static const int cube_vertex[6][4] = {
			{2,0,1,3},
			{4,6,7,5},
			{6,2,3,7},
			{7,3,1,5},
			{5,1,0,4},
			{4,0,2,6}
		};
		bullet->polygon[i].n_vtx = 4;
		bullet->polygon[i].polytype = POLYTYPE_FLAT;
		bullet->polygon[i].texture = NULL;
		bullet->polygon[i].p = &bullet->polyvtx[i*4];
		bullet->polyvtx[i*4].c = COLOUR_BULLET;
		bullet->polyvtx[i*4  ].vtx = &bullet->vertex[cube_vertex[i][0]];
		bullet->polyvtx[i*4+1].vtx = &bullet->vertex[cube_vertex[i][1]];
		bullet->polyvtx[i*4+2].vtx = &bullet->vertex[cube_vertex[i][2]];
		bullet->polyvtx[i*4+3].vtx = &bullet->vertex[cube_vertex[i][3]];
	}
}



#define BULLET_RADIUS 0.04f

void add_bullet_polygons(BSP_TREE *tree, BULLET *bullet)
{
	float xo = fixtof(bullet->x), yo = fixtof(bullet->y), zo = fixtof(bullet->z);
	int i;

	bullet->vertex[0].x = bullet->vertex[2].x = bullet->vertex[4].x = bullet->vertex[6].x = xo - BULLET_RADIUS;
	bullet->vertex[1].x = bullet->vertex[3].x = bullet->vertex[5].x = bullet->vertex[7].x = xo + BULLET_RADIUS;
	bullet->vertex[0].y = bullet->vertex[1].y = bullet->vertex[4].y = bullet->vertex[5].y = yo - BULLET_RADIUS;
	bullet->vertex[2].y = bullet->vertex[3].y = bullet->vertex[6].y = bullet->vertex[7].y = yo + BULLET_RADIUS;
	bullet->vertex[0].z = bullet->vertex[1].z = bullet->vertex[2].z = bullet->vertex[3].z = zo - BULLET_RADIUS;
	bullet->vertex[4].z = bullet->vertex[5].z = bullet->vertex[6].z = bullet->vertex[7].z = zo + BULLET_RADIUS;

	for (i = 0; i < 6; i++) {
		POLYGON *polygon = &bullet->polygon[i];
		prepare_polygon(polygon);
		add_temp_to_bsp_tree(tree, polygon);
	}
}



void prepare_bullet_vertices(MATRIX_f *camera, BULLET *bullet)
{
	int i;
	for (i = 0; i < 8; i++) draw_prepare_vertex(camera, &bullet->vertex[i]);
}
