#include <math.h>
#include "main.h"
#include "fractal.h"
#include "timeloop.h"


#if 0
static float find_edge(float x, float y)
{
	float min_d = 0.25f;
	float max_d = 2.0f;
	int i;

	for (i = 0; i < 8; i++) {
		float d = (min_d + max_d) * 0.5f;
		float cx = x * d, cy = y * d;
		int n = 1;
		float zx = cx, zy = cy;
		do {
			float t;
			if (++n == 16) break;
			t = zx*zx - zy*zy;
			zy = 2*zx*zy + cy;
			zx = t + cx;
		} while (zx*zx + zy*zy < 2*2);
		if (n == 16)
			min_d = d;
		else
			max_d = d;
	}

	return (min_d + max_d) * 0.5f;
}
#endif


void render_fractal(void)
{
	int x, y;
	float cx = cos(logic_time * 0.01f);
	float cy = sin(logic_time * 0.01f);
	float rc = cos(logic_time * 0.02f);
	float rs = sin(logic_time * 0.02f);
	float z0x, z0y;
	clear_to_color(the_fractal_bitmap, 240);
	cy *= 1.0f - 0.5f * cx;
	cx *= 1.0f - 0.5f * cx;
	for (y = 0, z0y = -1.0f; y < 256; y++, z0y += 2.0f/256.0f) {
		for (x = 0, z0x = -1.0f; x < 256; x++, z0x += 2.0f/256.0f) {
			int n = 0;
			float zx =  z0x * rc + z0y * rs;
			float zy = -z0x * rs + z0y * rc;
			do {
				float t;
				if (++n == 16) break;
				t = zx*zx - zy*zy;
				zy = 2*zx*zy + cy;
				zx = t + cx;
			} while (zx*zx + zy*zy < 2*2);
			the_fractal_bitmap->line[y][x] = MAX(the_fractal_bitmap->line[y][x], 239 + n);
			the_fractal_bitmap->line[255-x][y] = MAX(the_fractal_bitmap->line[255-x][y], 239 + n);
		}
	}
}
