#include <string.h>
#include <stdlib.h>
#include "main.h"
#include "game.h"
#include "level.h"
#include "drawpod.h"

#define W TILE_WALL
static unsigned char the_map[32][32] = {
	{W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W},
	{W,0,0,0,0,0,0,0,W,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,W},
	{W,0,0,0,0,0,0,0,W,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,W},
	{W,0,0,0,0,0,0,0,W,0,W,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,W},
	{W,0,0,0,0,0,0,0,W,0,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,0,0,0,W},
	{W,0,0,0,0,0,0,0,W,0,W,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,W},
	{W,0,0,0,0,0,0,0,0,0,W,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,W},
	{W,0,0,0,0,0,0,0,0,0,W,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,W},
	{W,W,W,W,W,W,W,W,W,W,W,0,0,0,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W},
	{W,0,0,0,0,0,0,0,0,0,W,0,0,0,W,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,W},
	{W,0,0,0,0,0,0,0,0,0,W,0,0,0,W,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,W},
	{W,0,0,0,0,0,0,0,0,0,W,0,0,0,W,0,0,0,0,0,W,W,W,W,W,W,W,W,W,0,0,W},
	{W,0,0,0,0,0,0,0,0,0,W,0,0,0,W,0,0,0,0,W,0,0,0,0,0,0,0,0,0,0,0,W},
	{W,0,0,0,0,0,0,0,0,0,W,0,0,0,W,0,0,0,W,0,0,0,0,0,0,0,0,0,0,0,0,W},
	{W,0,0,0,0,0,0,0,0,0,W,0,0,0,0,0,0,W,0,0,0,W,W,W,W,W,W,W,W,W,W,W},
	{W,0,0,0,0,0,0,0,0,0,W,0,0,0,0,0,W,0,0,0,W,0,0,0,0,0,0,0,0,0,0,W},
	{W,0,0,0,0,0,0,0,0,0,W,0,0,0,0,W,0,0,0,W,0,0,0,0,0,0,0,0,0,0,0,W},
	{W,0,0,0,0,0,0,0,0,0,W,0,0,0,W,0,0,0,W,0,0,0,0,0,0,0,0,0,0,0,0,W},
	{W,0,0,0,0,0,0,0,0,0,W,W,W,W,0,0,0,W,0,0,0,0,0,0,0,0,0,0,0,0,0,W},
	{W,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,W,0,0,0,0,0,0,0,0,0,0,0,0,0,0,W},
	{W,0,0,0,0,0,0,0,0,0,0,0,0,0,0,W,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,W},
	{W,0,0,0,0,0,0,0,0,0,W,W,W,W,W,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,W},
	{W,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,W},
	{W,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,W},
	{W,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,W},
	{W,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,W},
	{W,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,W},
	{W,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,W},
	{W,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,W},
	{W,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,W},
	{W,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,W},
	{W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W,W}
};
#undef W

static unsigned char *map_rows[] = {
	the_map[ 0], the_map[ 1], the_map[ 2], the_map[ 3], the_map[ 4], the_map[ 5], the_map[ 6], the_map[ 7],
	the_map[ 8], the_map[ 9], the_map[10], the_map[11], the_map[12], the_map[13], the_map[14], the_map[15],
	the_map[16], the_map[17], the_map[18], the_map[19], the_map[20], the_map[21], the_map[22], the_map[23],
	the_map[24], the_map[25], the_map[26], the_map[27], the_map[28], the_map[29], the_map[30], the_map[31]
};

static LEVEL the_level = {32, 32, map_rows};
static LEVEL *level = &the_level;


static POLYGON *new_polygon(GAME *game, int n_vtx)
{
	POLYGON *polygon = &game->polygon[game->n_polygons];
	polygon->n_vtx = n_vtx;
	polygon->p = malloc(n_vtx * sizeof(*polygon->p));
	if (!polygon->p) return NULL;
	game->n_polygons++;
	return polygon;
}


static int add_y_aligned_edges(GAME *game, VERTEX *(**vtxmap)[2], int x)
{
	int y;
	for (y = 0; y < game->map_h; y++) {
		int toleft = x > 0 ? TILE_IS_HIGH(game->map[y][x-1]) : 0;
		int toright = x < game->map_w ? TILE_IS_HIGH(game->map[y][x]) : 0;
		if (toleft && !toright) {
			POLYGON *polygon = new_polygon(game, 4);
			if (!polygon) return 1;
			polygon->texture = dat[GFX_TEX_WALL].dat;
			polygon->polytype = POLYTYPE_PTEX;
			polygon->p[0].vtx = vtxmap[y+1][x][1];
			polygon->p[1].vtx = vtxmap[y+1][x][0];
			polygon->p[2].vtx = vtxmap[y][x][0];
			polygon->p[3].vtx = vtxmap[y][x][1];
			polygon->p[0].u = 0.0001f; polygon->p[0].v = 0.0001f;
			polygon->p[1].u = 0.0001f; polygon->p[1].v = 0.9999f;
			polygon->p[2].u = 0.9999f; polygon->p[2].v = 0.9999f;
			polygon->p[3].u = 0.9999f; polygon->p[3].v = 0.0001f;
			prepare_polygon(polygon);
			add_to_bsp_tree(game->bsp_tree, polygon, NULL);
		} else if (toright && !toleft) {
			POLYGON *polygon = new_polygon(game, 4);
			if (!polygon) return 1;
			polygon->texture = dat[GFX_TEX_WALL].dat;
			polygon->polytype = POLYTYPE_PTEX;
			polygon->p[0].vtx = vtxmap[y][x][1];
			polygon->p[1].vtx = vtxmap[y][x][0];
			polygon->p[2].vtx = vtxmap[y+1][x][0];
			polygon->p[3].vtx = vtxmap[y+1][x][1];
			polygon->p[0].u = 0.0001f; polygon->p[0].v = 0.0001f;
			polygon->p[1].u = 0.0001f; polygon->p[1].v = 0.9999f;
			polygon->p[2].u = 0.9999f; polygon->p[2].v = 0.9999f;
			polygon->p[3].u = 0.9999f; polygon->p[3].v = 0.0001f;
			prepare_polygon(polygon);
			add_to_bsp_tree(game->bsp_tree, polygon, NULL);
		}
	}
	return 0;
}


static int add_x_aligned_edges(GAME *game, VERTEX *(**vtxmap)[2], int y)
{
	int x;
	for (x = 0; x < game->map_w; x++) {
		int totop = y > 0 ? TILE_IS_HIGH(game->map[y-1][x]) : 0;
		int tobottom = y < game->map_h ? TILE_IS_HIGH(game->map[y][x]) : 0;
		if (totop && !tobottom) {
			POLYGON *polygon = new_polygon(game, 4);
			if (!polygon) return 1;
			polygon->texture = dat[GFX_TEX_WALL].dat;
			polygon->polytype = POLYTYPE_PTEX;
			polygon->p[0].vtx = vtxmap[y][x][1];
			polygon->p[1].vtx = vtxmap[y][x][0];
			polygon->p[2].vtx = vtxmap[y][x+1][0];
			polygon->p[3].vtx = vtxmap[y][x+1][1];
			polygon->p[0].u = 0.0001f; polygon->p[0].v = 0.0001f;
			polygon->p[1].u = 0.0001f; polygon->p[1].v = 0.9999f;
			polygon->p[2].u = 0.9999f; polygon->p[2].v = 0.9999f;
			polygon->p[3].u = 0.9999f; polygon->p[3].v = 0.0001f;
			prepare_polygon(polygon);
			add_to_bsp_tree(game->bsp_tree, polygon, NULL);
		} else if (tobottom && !totop) {
			POLYGON *polygon = new_polygon(game, 4);
			if (!polygon) return 1;
			polygon->texture = dat[GFX_TEX_WALL].dat;
			polygon->polytype = POLYTYPE_PTEX;
			polygon->p[0].vtx = vtxmap[y][x+1][1];
			polygon->p[1].vtx = vtxmap[y][x+1][0];
			polygon->p[2].vtx = vtxmap[y][x][0];
			polygon->p[3].vtx = vtxmap[y][x][1];
			polygon->p[0].u = 0.0001f; polygon->p[0].v = 0.0001f;
			polygon->p[1].u = 0.0001f; polygon->p[1].v = 0.9999f;
			polygon->p[2].u = 0.9999f; polygon->p[2].v = 0.9999f;
			polygon->p[3].u = 0.9999f; polygon->p[3].v = 0.0001f;
			prepare_polygon(polygon);
			add_to_bsp_tree(game->bsp_tree, polygon, NULL);
		}
	}
	return 0;
}


static int add_surface(GAME *game, VERTEX *(**vtxmap)[2], int x, int y)
{
	int high = TILE_IS_HIGH(game->map[y][x]) ? 1 : 0;
	POLYGON *polygon = new_polygon(game, 4);
	if (!polygon) return 1;
	polygon->texture = dat[high ? GFX_TEX_WALL : GFX_TEX_FLOOR].dat;
	polygon->polytype = POLYTYPE_PTEX;
	polygon->p[0].vtx = vtxmap[y][x][high];
	polygon->p[1].vtx = vtxmap[y+1][x][high];
	polygon->p[2].vtx = vtxmap[y+1][x+1][high];
	polygon->p[3].vtx = vtxmap[y][x+1][high];
	polygon->p[0].u = 0.0001f; polygon->p[0].v = 0.0001f;
	polygon->p[1].u = 0.0001f; polygon->p[1].v = 0.9999f;
	polygon->p[2].u = 0.9999f; polygon->p[2].v = 0.9999f;
	polygon->p[3].u = 0.9999f; polygon->p[3].v = 0.0001f;
	prepare_polygon(polygon);
	add_to_bsp_tree(game->bsp_tree, polygon, NULL);
	return 0;
}


static int add_x_aligned_edges_in_range(GAME *game, VERTEX *(**vtxmap)[2], int y_min, int y_max)
{
	int y_mid = (y_min + y_max) >> 1;
	if (add_x_aligned_edges(game, vtxmap, y_mid)) return 1;
	if (y_mid > y_min) if (add_x_aligned_edges_in_range(game, vtxmap, y_min, y_mid - 1)) return 1;
	if (y_mid < y_max) if (add_x_aligned_edges_in_range(game, vtxmap, y_mid + 1, y_max)) return 1;
	return 0;
}


static int add_y_aligned_edges_in_range(GAME *game, VERTEX *(**vtxmap)[2], int x_min, int x_max)
{
	int x_mid = (x_min + x_max) >> 1;
	if (add_y_aligned_edges(game, vtxmap, x_mid)) return 1;
	if (x_mid > x_min) if (add_y_aligned_edges_in_range(game, vtxmap, x_min, x_mid - 1)) return 1;
	if (x_mid < x_max) if (add_y_aligned_edges_in_range(game, vtxmap, x_mid + 1, x_max)) return 1;
	return 0;
}


static int create_pod(GAME *game, unsigned char id, int x, int y, int dir, const int *dim)
{
	POD *pod = malloc(sizeof(*pod));
	if (!pod) return 1;
	pod->next = game->pod;
	game->pod = pod;
	pod->x = (x << 16) + (1 << 15);
	pod->y = (y << 16) + (1 << 15);
	pod->z = 0;
	pod->phi = dir * 0x200000;
	pod->xv = game->pod->yv = game->pod->zv = game->pod->phiv = 0;
	pod->flags = 0;
	pod->id = id;
	pod->state = POD_STATE_FALLING;
	pod->health = POD_HEALTH_INITIAL;
	pod->invinc_time = 0;
	pod->cloak_time = 0;
	pod->fire_delay = 0;
	pod->view_dim = dim;
	init_pod_polygons(pod);
	return 0;
}


GAME *create_game(int n_players)
{
	GAME *game = malloc(sizeof(*game));
	int x, y;
	VERTEX *(**vtxmap)[2] = NULL;

	if (!game) return NULL;
	game->map = NULL;
	game->pod = NULL;
	game->bullet = NULL;
	game->explosion = NULL;
	game->powerup = NULL;
	game->new_powerup_time = NEW_POWERUP_TIME;
	game->n_powerups = 0;
	game->bsp_tree = NULL;
	game->n_polygons = 0;
	game->polygon = NULL;

	game->map_w = level->map_w;
	game->map_h = level->map_h;
	game->map = malloc(game->map_h * sizeof(game->map[0]));
	if (!game->map) goto fail;
	game->map[0] = malloc(game->map_w * game->map_h * sizeof(game->map[0][0]));
	if (!game->map[0]) goto fail;
	for (y = 1; y < game->map_h; y++)
		game->map[y] = game->map[y-1] + game->map_w;
	for (y = 0; y < game->map_h; y++)
		memcpy(game->map[y], level->map[y], game->map_w);

	{
		static const int dimensions[4][4][4] = {
			{{0,0,4,4}, {0,0,0,0}, {0,0,0,0}, {0,0,0,0}},
			{{0,1,2,2}, {2,1,2,2}, {0,0,0,0}, {0,0,0,0}},
			{{0,0,2,2}, {1,2,2,2}, {2,0,2,2}, {0,0,0,0}},
			{{0,0,2,2}, {0,2,2,2}, {2,2,2,2}, {2,0,2,2}}
		};
		const int (*dim)[4] = dimensions[n_players-1];

		for (y = 0; y < n_players; y++)
			if (create_pod(game, y, 1+y, 1, 2+y, dim[y])) goto fail;
	}

	game->bsp_tree = create_bsp_tree();
	if (!game->bsp_tree) goto fail;

	game->vertex = malloc((game->map_w*game->map_h + game->map_w + game->map_h + 1) * 2 * sizeof(*game->vertex));
	if (!game->vertex) goto fail;
	game->n_vertices = 0;

	vtxmap = malloc((game->map_h + 1) * sizeof(*vtxmap));
	if (!vtxmap) goto fail;
	vtxmap[0] = malloc((game->map_w*game->map_h + game->map_w + game->map_h + 1) * sizeof(**vtxmap));
	if (!vtxmap[0]) goto fail;
	for (y = 1; y < game->map_h + 1; y++)
		vtxmap[y] = vtxmap[y-1] + game->map_w + 1;

	for (y = 0; y < game->map_h + 1; y++) {
		for (x = 0; x < game->map_w + 1; x++) {
			int flags = 0;
			if (x > 0 && y > 0 && TILE_IS_HIGH(game->map[y-1][x-1])) flags |= 2; else flags |= 1;
			if (x > 0 && y < game->map_h && TILE_IS_HIGH(game->map[y][x-1])) flags |= 2; else flags |= 1;
			if (x < game->map_w && y > 0 && TILE_IS_HIGH(game->map[y-1][x])) flags |= 2; else flags |= 1;
			if (x < game->map_w && y < game->map_h && TILE_IS_HIGH(game->map[y][x])) flags |= 2; else flags |= 1;
			if (flags & 1) {
				vtxmap[y][x][0] = &game->vertex[game->n_vertices++];
				vtxmap[y][x][0]->x = (float)x;
				vtxmap[y][x][0]->y = (float)y;
				vtxmap[y][x][0]->z = 0;
			}
			if (flags & 2) {
				vtxmap[y][x][1] = &game->vertex[game->n_vertices++];
				vtxmap[y][x][1]->x = (float)x;
				vtxmap[y][x][1]->y = (float)y;
				vtxmap[y][x][1]->z = PHYSICAL_WALL_HEIGHT;
			}
		}
	}

	/* Save some memory */
	{
		VERTEX *condense = realloc(game->vertex, game->n_vertices * sizeof(*game->vertex));
		if (condense) game->vertex = condense;
	}

	game->polygon = malloc((game->map_w*game->map_h*3 + game->map_w + game->map_h) * sizeof(*game->polygon));
	if (!game->polygon) goto fail;
	game->n_polygons = 0;

	if (add_x_aligned_edges_in_range(game, vtxmap, 0, game->map_h)) goto fail;
	if (add_y_aligned_edges_in_range(game, vtxmap, 0, game->map_w)) goto fail;

	for (y = 0; y < game->map_h; y++)
		for (x = 0; x < game->map_w; x++)
			if (add_surface(game, vtxmap, x, y)) goto fail;

	if (vtxmap) {
		if (vtxmap[0]) free(vtxmap[0]);
		free(vtxmap);
		vtxmap = NULL;
	}

	/* Save some more memory */
	{
		POLYGON *condense = realloc(game->polygon, game->n_polygons * sizeof(*game->polygon));
		if (condense) game->polygon = condense;
	}

	finalise_bsp_tree(game->bsp_tree, 0);

	return game;

	fail:
	if (vtxmap) {
		if (vtxmap[0]) free(vtxmap[0]);
		free(vtxmap);
	}
	destroy_game(game);
	return NULL;
}


void destroy_game(GAME *game)
{
	if (game) {
		if (game->map) {
			if (game->map[0]) free(game->map[0]);
			free(game->map);
		}
		while (game->pod) {
			POD *next = game->pod->next;
			free(game->pod);
			game->pod = next;
		}
		while (game->bullet) {
			BULLET *next = game->bullet->next;
			free(game->bullet);
			game->bullet = next;
		}
		while (game->explosion) {
			EXPLOSION *next = game->explosion->next;
			free(game->explosion);
			game->explosion = next;
		}
		while (game->powerup) {
			POWERUP *next = game->powerup->next;
			free(game->powerup);
			game->powerup = next;
		}
		if (game->bsp_tree) destroy_bsp_tree(game->bsp_tree);
		if (game->polygon) {
			int i;
			for (i = 0; i < game->n_polygons; i++) free(game->polygon[i].p);
			free(game->polygon);
		}
		if (game->vertex) free(game->vertex);
		free(game);
	}
}
