#ifndef INC_MAIN_H
#define INC_MAIN_H


#include <stdlib.h>
#include <allegro.h>
#include <dumb.h>


#define RND(x) (rand() * ((x) / (float)RAND_MAX))


#include "datafile.h"
extern DATAFILE *dat;
extern COLOR_MAP the_trans_map;
extern BITMAP *the_fractal_bitmap;
extern int joystick_installed;
extern int show_fps;

#define COLOUR_BULLET 1
#define COLOUR_YELLOW 2
#define COLOUR_RED 3
#define COLOUR_DARK_GREY 4
#define FLOAT_COLOUR_EXPLOSION_DARK   240.01f
#define FLOAT_COLOUR_EXPLOSION_BRIGHT 255.99f


void poll_stuff(void);


#ifdef DEBUGMALLOC
#include <stdio.h>
/* These functions will exist separately for all source files. */
static int malloc_count_n = 0;
static int malloc_virgin = 1;

static void output_count(void)
{
	fprintf(stderr, "%s : %d\n", __FILE__, malloc_count_n);
}

static void *malloc_count(size_t size)
{
	void *ptr;

	if (malloc_virgin) {
		atexit(&output_count);
		malloc_virgin = 0;
	}

	ptr = malloc(size);
	if (ptr) malloc_count_n++;
	return ptr;
}

static void *realloc_count(void *ptr, size_t size)
{
	void *newptr;

	if (malloc_virgin) {
		atexit(&output_count);
		malloc_virgin = 0;
	}

	newptr = realloc(ptr, size);
	if (!ptr && newptr) malloc_count_n++;

	return newptr;
}

static void free_count(void *ptr)
{
	free(ptr);
	malloc_count_n--;
}

#define malloc malloc_count
#define realloc realloc_count
#define free free_count

#endif


#endif /* INC_MAIN_H */

